<template>
  <v-layout align-center justify-center mt-8>
    <v-flex xs12 sm8 md4>
      <v-card max-width="756" class="mx-auto">
        <v-toolbar color="#2A72A1" dark>
          <!-- <v-app-bar-nav-icon></v-app-bar-nav-icon> -->

          <v-toolbar-title>To-Do List</v-toolbar-title>
          <v-spacer></v-spacer>
          <a @click="getTasks(uncheckedData)"
            ><small>{{ changeStatusText }} </small></a
          >
        </v-toolbar>

        <v-list
          subheader
          two-line
          flat
          height="600"
          class="v-class"
          style="overflow: scroll"
        >
          <v-list-item-group multiple>
            <v-row>
              <v-col>
                <div class="mt-3 mr-2 ml-2">
                  <div v-if="ShowDeafaultImage" style="text-align: center">
                    <img src="../../../public/images/default.png" alt="" />
                  </div>

                  <v-list-item
                    v-for="task in tasks"
                    :key="task.id"
                    class="divided-items"
                    @click="showEditForm(event, task.id)"
                  >
                    <template>
                      <v-list-item-action>
                        <v-checkbox
                          @change="changeStatus(task)"
                          :value="!task.is_checked"
                          input-value="true"
                          color="primary"
                        ></v-checkbox>
                      </v-list-item-action>

                      <v-list-item-content>
                        <v-list-item-title>{{ task.title }}</v-list-item-title>
                        <v-list-item-subtitle
                          ><small
                            ><v-icon small color="#E5695A">mdi-calendar</v-icon>
                            Due Date: {{ task.due_date }}</small
                          ></v-list-item-subtitle
                        >
                      </v-list-item-content>

                      <v-list-item-action
                        v-for="category in task.categories"
                        :key="category.id"
                      >
                        <div class="category-item">
                          {{ category.title }}
                        </div>
                      </v-list-item-action>

                      <v-menu
                        bottom
                        right
                        transition="slide-x-transition"
                        content-class="menu-item"
                      >
                        <template v-slot:activator="{ on, attrs }">
                          <v-btn icon v-bind="attrs" v-on="on">
                            <v-icon>mdi-dots-vertical</v-icon>
                          </v-btn>
                        </template>
                        <v-list>
                          <v-dialog v-model="dialog" width="500">
                            <template v-slot:activator="{ on }">
                              <v-list-item v-on="on">
                                <v-list-item-action>
                                  <v-icon color="#607D8B">mdi-pencil</v-icon>
                                </v-list-item-action>
                                <v-list-item-content>
                                  <v-list-item-title
                                    >Edit Task</v-list-item-title
                                  >
                                </v-list-item-content>
                              </v-list-item>
                            </template>

                            <v-card>
                              <v-card-title> Edit Task </v-card-title>

                              <v-card-text>
                                <v-form
                                  ref="form"
                                  v-model="valid"
                                  lazy-validation
                                >
                                  <v-text-field
                                    v-model="name"
                                    :rules="nameRules"
                                    label="Task Title"
                                    required
                                    outlined
                                  ></v-text-field>

                                  <v-select
                                    v-model="select"
                                    :items="categories"
                                    :id="categories"
                                    label="Select Category"
                                    required
                                    outlined
                                  ></v-select>

                                  <v-text-field
                                    v-model="date"
                                    :rules="nameRules"
                                    label="Name"
                                    required
                                    outlined
                                  ></v-text-field>

                                  <v-btn
                                    color="#B90101"
                                    class="mr-4 form-btn-class"
                                    @click="validate"
                                  >
                                    Delete
                                  </v-btn>

                                  <v-btn
                                    color="#565656"
                                    class="form-btn-class"
                                    @click="reset"
                                  >
                                    Cancel
                                  </v-btn>

                                  <v-btn
                                    color="#023C6D"
                                    class="form-btn-class"
                                    @click="resetValidation"
                                  >
                                    Save Task
                                  </v-btn>
                                </v-form>
                              </v-card-text>
                            </v-card>
                          </v-dialog>

                          <v-list-item @click="changeStatus(task)">
                            <v-list-item-action>
                              <v-icon color="green">mdi-checkbox-marked</v-icon>
                            </v-list-item-action>
                            <v-list-item-content>
                              <v-list-item-title
                                >Mark as Complete</v-list-item-title
                              >
                            </v-list-item-content>
                          </v-list-item>

                          <v-divider></v-divider>

                          <v-list-item @click="deleteTask(task.id)">
                            <v-list-item-action>
                              <v-icon color="#F44336">mdi-close-box</v-icon>
                            </v-list-item-action>
                            <v-list-item-content>
                              <v-list-item-title>Delete Task</v-list-item-title>
                            </v-list-item-content>
                          </v-list-item>
                        </v-list>
                      </v-menu>
                    </template>
                  </v-list-item>
                </div>
              </v-col>
            </v-row>
          </v-list-item-group>

          <v-card class="form-card">
            <v-form>
              <v-container>
                <v-row>
                  <v-col cols="12">
                    <v-text-field
                      v-model="fields.task"
                      outlined
                      clearable
                      label="Add Task"
                      type="text"
                      class="input-task"
                    >
                      <template v-slot:append-outer>
                        <v-btn
                          @click="addTask()"
                          color="#023C6D"
                          class="add-button"
                        >
                          Add Task
                        </v-btn>
                      </template>
                    </v-text-field>
                  </v-col>
                </v-row>
              </v-container>
            </v-form>
          </v-card>
        </v-list>
      </v-card>
    </v-flex>
  </v-layout>
</template>

<script>
export default {
  data: () => ({
    dialog: false,
    fields: {},
    tasks: [],
    uncheckedData: true,
    data: [],
    changeStatusText: "Completed Tasks",
    inProgressTasks: 0,
    ShowDeafaultImage: false,
    categories: [],
  }),
  watch: {
    tasks() {
        console.log(this.tasks.filter((todo) => todo.is_checked == true));
      this.ShowDeafaultImage =
        this.tasks.filter((todo) => todo.is_checked == false).length == 0 &&
        this.changeStatusText == "Completed Tasks"
          ? true
          : false;
    },
  },
  methods: {
    addTask() {
      //store tasks
      axios
        .post("/api/tasks/store", this.fields)
        .then((response) => {
          response = response.data.data;
          var data = {
            id: response.id,
            title: response.title,
            due_date: response.due_date,
            is_checked: false,
          };
          this.tasks.unshift(data);
          this.fields = {};
        })
        .catch((error) => {
          this.errors = error.response.data.errors;
        });
    },
    getTasks() {
      // return all tasks
      axios
        .get("/api/tasks/")
        .then((response) => {
          this.data = response.data.data;
          this.tasks = this.data.filter(
            (todo) => todo.is_checked != this.uncheckedData
          );
          this.uncheckedData = !this.uncheckedData;
          this.changeStatusText =
            this.uncheckedData == true
              ? "In Progress Tasks"
              : "Completed Tasks";
        })
        .catch((error) => {
          this.errors = error.response.data.errors;
        });
    },
    getCategories() {
      // return all tasks
      axios
        .get("/api/categories/")
        .then((response) => {
          this.categories = [];
          response.data.data.forEach((category) => {
            this.categories.push(category.title);
          });
        })
        .catch((error) => {
          this.errors = error.response.data.errors;
        });
    },

    changeStatus(task) {
      // change is_checked status
      axios
        .post("/api/tasks/update/status/" + task.id)
        .then((response) => {
          console.log(response.data.data);

          this.tasks = this.tasks.filter((todo) => todo != task);

          // this.inProgressTasks = this.data.filter(todo => todo.is_checked == false).length
        })
        .catch((error) => {
          this.errors = error.response.data.errors;
        });
    },
    deleteTask(taskId) {
      // delete a task
      axios
        .delete("/api/tasks/" + taskId)
        .then((response) => {
          // TO DO
        })
        .catch((error) => {
          this.errors = error.response.data.errors;
        });
    },
  },

  mounted() {
    this.getTasks();
    this.getCategories();
  },
};
</script>

<style scoped>
a {
  text-decoration: none;
  color: antiquewhite !important;
}
.divided-items {
  border: 1px solid gainsboro;
  border-radius: 5px;
  margin: 10px 0;
}

.form-card {
  position: absolute !important;
  width: 100% !important;
  bottom: -100px;
}
.input-task {
  top: 15px !important;
}
.add-button {
  bottom: 8px !important;
  color: white;
}
.container {
  -ms-overflow-style: none; /* Internet Explorer 10+ */
  scrollbar-width: none; /* Firefox */
}

.v-class {
  overflow-y: auto;
  scrollbar-width: none;
  -ms-overflow-style: none;
}
.v-class::-webkit-scrollbar {
  width: 0 !important;
}
.menu-item {
  margin-top: 35px;
}
.category-item {
  width: 83px;
  height: 38px;
  border: 0.12rem solid #2a72a1;
  border-radius: 20px;
  margin: 0 5px;
  font-size: 12px;
  vertical-align: middle;
  display: flex;
  align-items: center;
  justify-content: center;
}
.form-btn-class {
  color: white;
}
</style>
